# class DurationUpdate | An UI time updater. More...
Full name | `TelEngine::DurationUpdate`
Definition | `#include <yatecbase.h>`
Inherits | TelEngine::RefObject [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- inline DurationUpdate (ClientLogic* logic, bool owner, const char* id, const char* name, unsigned int start = Time::secNow())
- virtual ~DurationUpdate ()
- virtual const String& toString () const
- void setLogic (ClientLogic* logic = 0, bool owner = true)
- virtual unsigned int update (unsigned int secNow, const String* table = 0, Window* wnd = 0, Window* skip = 0, bool force = false)
- virtual unsigned int buildTimeParam (NamedList& dest, unsigned int secNow, bool force = false)
- virtual unsigned int buildTimeString (String& dest, unsigned int secNow, bool force = false)

#### Public Static Methods

- static unsigned int buildTimeParam (NamedList& dest, const char* param, unsigned int secStart, unsigned int secNow, bool force = false)
- static unsigned int buildTimeString (String& dest, unsigned int secStart, unsigned int secNow, bool force = false)

#### Protected Methods

- virtual void destroyed ()

#### Protected Members

- String m_id
- ClientLogic* m_logic
- String m_name
- unsigned int m_startTime

## Detailed Description

Class used to update UI durations. The string keeps the object's id. This object can be used to keep additional data associated with a client channel

inline DurationUpdate (ClientLogic* logic, bool owner, const char* id, const char* name, unsigned int start = Time::secNow()) | ### DurationUpdate

Constructor. Add itself to logic's list

Parameters:

logic | The client logic used to update this duration object
owner | True if the logic is owning this object
id | Object id
name | Object name (widget or column name)
start | Start time in seconds

~DurationUpdate () | ### ~DurationUpdate

[virtual]

Destructor

const String& toString () | ### toString

[const virtual]

Get a string representation of this object

Returns: This duration's id

Reimplemented from GenObject.

void setLogic (ClientLogic* logic = 0, bool owner = true) | ### setLogic

Set the logic used to update this duration object. Remove from the old one

Parameters:

logic | The client logic used to update this duration object
owner | True if the logic is owning this object

unsigned int update (unsigned int secNow, const String* table = 0, Window* wnd = 0, Window* skip = 0, bool force = false) | ### update

[virtual]

Update UI if duration is non 0

Parameters:

secNow | Current time in seconds
table | The table to update. Set to 0 to update text widgets
wnd | Optional window to update
skip | Optional window to skip if wnd is 0
force | Set to true to update even if duration is 0

Returns: The duration

unsigned int buildTimeParam (NamedList& dest, unsigned int secNow, bool force = false) | ### buildTimeParam

[virtual]

Build a duration string representation and add the parameter to a list

Parameters:

dest | Destination list
secNow | Current time in seconds
force | Set to true to add the parameter even if duration is 0

Returns: The duration

unsigned int buildTimeString (String& dest, unsigned int secNow, bool force = false) | ### buildTimeString

[virtual]

Build a duration string representation hh:mm:ss. The hours are added only if non 0

Parameters:

dest | Destination string
secNow | Current time in seconds
force | Set to true to build even if duration is 0

Returns: The duration

unsigned int buildTimeParam (NamedList& dest, const char* param, unsigned int secStart, unsigned int secNow, bool force = false) | ### buildTimeParam

[static]

Build a duration string representation and add the parameter to a list

Parameters:

dest | Destination list
param | Parameter to add
secStart | Starting time in seconds
secNow | Current time in seconds
force | Set to true to add the parameter even if duration is 0

Returns: The duration

unsigned int buildTimeString (String& dest, unsigned int secStart, unsigned int secNow, bool force = false) | ### buildTimeString

[static]

Build a duration string representation hh:mm:ss. The hours are added only if non 0

Parameters:

dest | Destination string
secStart | Starting time in seconds
secNow | Current time in seconds
force | Set to true to build even if duration is 0

Returns: The duration

void destroyed () | ### destroyed

[protected virtual]

Release memory. Remove from updater

Reimplemented from RefObject.

String m_id | ### m_id

[protected]

ClientLogic* m_logic | ### m_logic

[protected]

String m_name | ### m_name

[protected]

unsigned int m_startTime | ### m_startTime

[protected]

Generated by: paulc on bussard on Mon Feb 10 13:15:47 2014, using kdoc 2.0a54.